import { AST_NODE_TYPES as e } from "@typescript-eslint/utils";
import t from "typescript";
let { getAllJSDocTags: r, isIdentifier: a, isJSDocDeprecatedTag: n, isJSDocLinkLike: i, isJSDocMemberName: o, isQualifiedName: s, isShorthandPropertyAssignment: p, TypeFormatFlags: c } = t;
import { getParserServices as d } from "@typescript-eslint/utils/eslint-utils";
import { createRule as u } from "../util/index.js";
function f(e) {
    return "string" == typeof e ? e : e.map((e)=>i(e) && e.name ? function(e) {
            let t = "", r = e;
            for(; r;){
                if (s(r) || o(r)) {
                    t = "" === t ? r.right.text : `${r.right.text}#${t}`, r = r.left;
                    continue;
                }
                if (a(r)) {
                    if ("" === t) return r.text;
                    t = `${r.text}#${t}`, r = void 0;
                    continue;
                }
                break;
            }
            return t;
        }(e.name) : e.text).join("");
}
function m(t, a, i, o, s, p) {
    if (o.type === e.Identifier && (o.parent.type === e.CallExpression || o.parent.type === e.NewExpression) && o.parent.callee === o) {
        let e = a.esTreeNodeToTSNodeMap.get(o.parent), s = i.getResolvedSignature(e);
        if (void 0 === s) return;
        let d = s.getDeclaration();
        if (void 0 === d) return;
        for (let a of r(d, n)){
            if (a.comment) {
                t.report({
                    messageId: "deprecatedSignatureWithReason",
                    node: o,
                    data: {
                        name: p,
                        signature: i.signatureToString(s, e, c.WriteTypeArgumentsOfSignature),
                        reason: f(a.comment)
                    }
                });
                break;
            }
            t.report({
                messageId: "deprecatedSignature",
                node: o,
                data: {
                    name: p,
                    signature: i.signatureToString(s, e, c.WriteTypeArgumentsOfSignature)
                }
            });
        }
        return;
    }
    for (let e of s.getDeclarations() ?? [])for (let a of r(e, n)){
        if (a.comment) {
            t.report({
                messageId: "deprecatedWithReason",
                node: o,
                data: {
                    name: p,
                    reason: f(a.comment)
                }
            });
            return;
        }
        t.report({
            messageId: "deprecated",
            node: o,
            data: {
                name: p
            }
        });
    }
}
export default u({
    name: "deprecation",
    meta: {
        docs: {
            description: "Disallow usage of deprecated APIs",
            requiresTypeChecking: !0
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        },
        messages: {
            deprecated: "'{{name}}' is deprecated.",
            deprecatedWithReason: "'{{name}}' is deprecated: {{reason}}",
            deprecatedSignature: "The signature '{{signature}}' of '{{name}}' is deprecated.",
            deprecatedSignatureWithReason: "The signature '{{signature}}' of '{{name}}' is deprecated: {{reason}}"
        },
        schema: [],
        type: "problem"
    },
    defaultOptions: [],
    create (t) {
        let r = d(t), a = r.program.getTypeChecker();
        return {
            Property (n) {
                let i = r.esTreeNodeToTSNodeMap.get(n);
                if (n.key.type === e.Identifier && p(i)) {
                    let e = a.getTypeAtLocation(i.name).getSymbol();
                    if (void 0 === e) return;
                    m(t, r, a, n, e, n.key.name);
                }
            },
            Identifier (n) {
                if (function(t) {
                    switch(t.parent.type){
                        case e.FunctionDeclaration:
                        case e.TSDeclareFunction:
                        case e.ClassDeclaration:
                        case e.TSInterfaceDeclaration:
                        case e.TSTypeAliasDeclaration:
                        case e.Property:
                            return !0;
                        case e.VariableDeclarator:
                            return t.parent.init !== t;
                        case e.TSPropertySignature:
                        case e.PropertyDefinition:
                            return t.parent.key === t;
                    }
                    return !1;
                }(n)) return;
                let i = r.getSymbolAtLocation(n);
                if (void 0 !== i) try {
                    m(t, r, a, n, i, n.name);
                } catch  {
                    return;
                }
            },
            MemberExpression (n) {
                if (n.property.type === e.PrivateIdentifier) {
                    let e = n.property, i = r.getSymbolAtLocation(e);
                    if (void 0 !== i) try {
                        m(t, r, a, e, i, `#${e.name}`);
                    } catch  {
                        return;
                    }
                }
            }
        };
    }
});

//# sourceMappingURL=deprecation.js.map